<?php
//--------------------------------------------------------------------
// *** Anti-Spam Module for Comment (asm4cmt) ***
// LAST UPDATE: 2014/04/14
// Version    : 3.30
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// function.php
//
//--------------------------------------------------------------------

/* ----- リンク先を読み込む ----- */
function get_html($url) {
	//URLからドメインとパスを取得
	$pattern = "/^(http:\/\/)([^\/]+)(\/.*$)/i";
	if ( preg_match ( $pattern, $url, $match ) ) {
		$domain = $match[2]; 
		$path = $match[3]; 
	}
	
	if ($match[0]) {
		//fsockopenを使ってサーバに接続
		$fp = @fsockopen ( $domain, 80 );
		if (!$fp) {
			exit();
		}

		//HTTPのリクエスト・メッセージ
		$request = "GET ".$path." HTTP/1.0\n"; //GET
		$request .= "Host: " .$domain. "\n"; //Host:
		$request .= "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)\n"; //UA
		$request .= "\n";
		fputs ( $fp, $request ); //リクエスト送信
		while ( !feof ( $fp ) ) {
			$html .= fgets ( $fp, 4096 );
		}
		fclose ( $fp );
	}
	return $html;
}

function asm4cmt_format_data($val) {
	$val = str_replace("\"", "&#34;", $val);
	$val = blogn_mod_db_rn2br($val);
	$val = blogn_mod_db_comma_change($val);
	return $val;
}

function asm4cmt_format_log($val) {
	$val = strip_tags($val);
	$val = htmlspecialchars($val);
	$val = str_replace(",", "&#44;", $val);
	$val = str_replace("\"", "&#34;", $val);
	$val = str_replace("\r", "", $val);
	$val = str_replace("\n", "", $val);
	return $val;
}

function asm4cmt_namelimit($name, $limit) {
	if (BLOGN_MBS) {
		if (mb_strlen($name) > $limit) $name = mb_substr($name, 0, $limit);
	}else{
		if (strlen($name) > $limit) {
			$name = substr($name, 0, $limit); 
			while(ord(substr($name,-1)) >= 0xc0 || ord(substr($name,-2)) >= 0xe0) {
				$name = substr($name, 0, -1);
			}
		}
	}
	return $name;
}

function asm4cmt_remove_rn($str) {
	$str = str_replace("\r\n", "\n", $str);
	$str = str_replace("\r", "\n", $str);
	$str = str_replace("\n",  "", $str);				// \nを文字列から消す。
	return $str;
}


// 引用
function asm4cmt_quote($str) {
	$lines = preg_split("/\r\n*/", $str);
	$message = "";
	for ($i = 0; $i < count($lines); $i++) {
		$message .= preg_replace("/^(＞|&gt;)([\w\W]+?)$/", "<span class=\"cmtquote\">\\1\\2</span>", $lines[$i]);
		$message .= "\r\n";
	}
	return $message;
}


// オートリンク
function asm4cmt_autolink($str, $target) {
	$str = ereg_replace('(https?)(://[[:alnum:]\S\$\+\?\.-=_%,:@!#~*/&^-]+)','<a href="\\1\\2" target="_'.$target.'" rel="nofollow">\\1\\2</a>', $str);
	return $str;
}

function asm4cmt_create_tsname() {
	$pw = "abcdefghkmnpqrstuvwxyz123456790";
	$pwelem = preg_split("//", $pw, 0, PREG_SPLIT_NO_EMPTY);
	$str = "t";
	for ($i = 0; $i < 7; $i++) {
		$str .= $pwelem[array_rand($pwelem, 1)];
	}
	return $str;
}
?>